diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
index fc6feae96..12e308c1e 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
@@ -38,51 +38,51 @@ public abstract class StatList
     public static final String STAT_MINED = "stat_mined";
 
     public static Stat startGameStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "start_game"), "stat.startGame").setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "start_game"), "stat.startGame").setClientside().registerStat();
     public static Stat createWorldStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "create_world"), "stat.createWorld").setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "create_world"), "stat.createWorld").setClientside().registerStat();
     public static Stat loadWorldStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "load_world"), "stat.loadWorld").setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "load_world"), "stat.loadWorld").setClientside().registerStat();
     public static Stat joinMultiplayerStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "join_multiplayer"), "stat.joinMultiplayer").setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "join_multiplayer"), "stat.joinMultiplayer").setClientside().registerStat();
     public static Stat leaveGameStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "leave_game"), "stat.leaveGame").setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "leave_game"), "stat.leaveGame").setClientside().registerStat();
     public static Stat minutesPlayedStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "playtime"), "stat.playOneMinute", Stat.statTypeTime).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "playtime"), "stat.playOneMinute", Stat.statTypeTime).setClientside().registerStat();
     public static Stat distanceWalkedStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_walk"), "stat.walkOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "travel_walk"), "stat.walkOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceSwumStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_swim"), "stat.swimOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "travel_swim"), "stat.swimOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceFallenStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_fall"), "stat.fallOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "travel_fall"), "stat.fallOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceClimbedStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_climb"), "stat.climbOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "travel_climb"), "stat.climbOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceFlownStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_fly"), "stat.flyOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "travel_fly"), "stat.flyOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceDoveStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_dive"), "stat.diveOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "travel_dive"), "stat.diveOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceByMinecartStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_minecart"), "stat.minecartOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "travel_minecart"), "stat.minecartOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceByBoatStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_boat"), "stat.boatOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "travel_boat"), "stat.boatOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat distanceByPigStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "travel_pig"), "stat.pigOneCm", Stat.statTypeDistance).setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "travel_pig"), "stat.pigOneCm", Stat.statTypeDistance).setClientside().registerStat();
     public static Stat jumpStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "jump"), "stat.jump").setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "jump"), "stat.jump").setClientside().registerStat();
     public static Stat dropStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "drop"), "stat.drop").setClientside().registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "drop"), "stat.drop").setClientside().registerStat();
     public static Stat damageDealtStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "damage_dealt"), "stat.damageDealt").registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "damage_dealt"), "stat.damageDealt").registerStat();
     public static Stat damageTakenStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "damage_taken"), "stat.damageTaken").registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "damage_taken"), "stat.damageTaken").registerStat();
     public static Stat deathsStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "deaths"), "stat.deaths").registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "deaths"), "stat.deaths").registerStat();
     public static Stat mobKillsStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "kills_mob"), "stat.mobKills").registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "kills_mob"), "stat.mobKills").registerStat();
     public static Stat playerKillsStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "kills_player"), "stat.playerKills").registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "kills_player"), "stat.playerKills").registerStat();
     public static Stat fishCaughtStat =
-        new StatBasic(NamespaceID.getPermanent("minecraft", "caught_fish"), "stat.fishCaught").registerStat();
+        new StatBasic(NamespaceID.fromPool("minecraft", "caught_fish"), "stat.fishCaught").registerStat();
 
     public static Map<NamespaceID, Stat> mobEncounterStats;
 
@@ -146,7 +146,7 @@ public abstract class StatList
         mobEncounterStats = new HashMap<>();
         for (Map.Entry<NamespaceID, Class<? extends Entity>> entry : EntityDispatcher.idToClassMap.entrySet())
         {
-            mobEncounterStats.put(entry.getKey(), new StatMob(NamespaceID.getPermanent("minecraft", "encounter_" + entry.getKey().toString().replace(":", "_")), "stat.encounterMob", entry.getKey()).registerStat());
+            mobEncounterStats.put(entry.getKey(), new StatMob(NamespaceID.fromPool("minecraft", "encounter_" + entry.getKey().toString().replace(":", "_")), "stat.encounterMob", entry.getKey()).registerStat());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
index 74af0d48f..6fd868976 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
@@ -164,7 +164,7 @@ public class StatsCounter {
 				Stat stat;
 				try {
 					if (statId.contains(":")) {
-						stat = StatList.getStat(NamespaceID.getTemp(statId));
+						stat = StatList.getStat(NamespaceID.fromPool(statId));
 					} else {
 						stat = StatList.StatConverter.getStatFromDeprecatedID(Integer.parseInt(statId));
 					}
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index 1fa72c0a0..d9a330088 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -112,7 +112,7 @@ public final class Block<T extends BlockLogic>
 //            namespaceId = parts[0] + ":" + "block/" + parts[1];
 //        }
         try {
-            return NamespaceID.getPermanent(namespaceId);
+            return NamespaceID.fromPool(namespaceId).copyUnpooled();
         } catch (HardIllegalArgumentException e) {
             throw new RuntimeException(e);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
index 0c7fe8451..a18bd25aa 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -34,7 +34,7 @@ import java.util.Objects;
 import java.util.Random;
 
 public class BlockLogic implements BlockInterface, IItemConvertible {
-    protected final AABB bounds = AABB.getPermanentBB(0, 0, 0, 1, 1, 1);
+    protected final AABB bounds = AABB.fromPool(0, 0, 0, 1, 1, 1).copyUnpooled();
     public final @NotNull Block<?> block;
     protected @NotNull Material material;
     public BlockLogic(Block<?> block, Material material) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index 41c1e5a65..bc595e9d9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -254,17 +254,17 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
         }
         switch (direction) {
             case SIDE_WEST:
-                return AABB.getTemporaryBB(0.0F, f, 0.5F - f2, f3, f1, 0.5F + f2);
+                return AABB.fromPool(0.0F, f, 0.5F - f2, f3, f1, 0.5F + f2);
             case SIDE_EAST:
-                return AABB.getTemporaryBB(1.0F - f3, f, 0.5F - f2, 1.0F, f1, 0.5F + f2);
+                return AABB.fromPool(1.0F - f3, f, 0.5F - f2, 1.0F, f1, 0.5F + f2);
             case SIDE_NORTH:
-                return AABB.getTemporaryBB(0.5F - f2, f, 0.0F, 0.5F + f2, f1, f3);
+                return AABB.fromPool(0.5F - f2, f, 0.0F, 0.5F + f2, f1, f3);
             case SIDE_SOUTH:
-                return AABB.getTemporaryBB(0.5F - f2, f, 1.0F - f3, 0.5F + f2, f1, 1.0F);
+                return AABB.fromPool(0.5F - f2, f, 1.0F - f3, 0.5F + f2, f1, 1.0F);
             case SIDE_TOP:
-                return AABB.getTemporaryBB(0.5f - f2, 1 - f3, f, 0.5f + f2, 1.0, f1);
+                return AABB.fromPool(0.5f - f2, 1 - f3, f, 0.5f + f2, 1.0, f1);
             case SIDE_BOTTOM:
-                return AABB.getTemporaryBB(0.5f - f2, 0, f, 0.5f + f2, f3, f1);
+                return AABB.fromPool(0.5f - f2, 0, f, 0.5f + f2, f3, f1);
         }
         return super.getBlockBoundsFromState(world, x, y, z);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java
index 35b817425..a0f40565b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java
@@ -21,7 +21,7 @@ public class BlockLogicCake extends BlockLogicEdible
         float f = 0.0625F;
         float f1 = (float)(1 + l * 2) / 16F;
         float f2 = 0.5F;
-        return AABB.getTemporaryBB(f1, 0.0F, f, 1.0F - f, f2, 1.0F - f);
+        return AABB.fromPool(f1, 0.0F, f, 1.0F - f, f2, 1.0F - f);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
index 78efd1aad..3be0632d0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCropsPumpkin.java
@@ -37,7 +37,7 @@ public class BlockLogicCropsPumpkin
             size = 14 * onePix;
         }
 
-        return AABB.getTemporaryBB(0.5F - size / 2, 0, 0.5F - size / 2, 0.5F + size / 2, size, 0.5F + size / 2);
+        return AABB.fromPool(0.5F - size / 2, 0, 0.5F - size / 2, 0.5F + size / 2, size, 0.5F + size / 2);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
index d75c04aa7..4097c59c6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
@@ -99,15 +99,15 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
         float f = 0.1875F;
         switch (rotation) {
             case 0:
-                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, 1.0F, top, f);
+                return AABB.fromPool(0.0F, bottom, 0.0F, 1.0F, top, f);
             case 1:
-                return AABB.getTemporaryBB(1.0F - f, bottom, 0.0F, 1.0F, top, 1.0F);
+                return AABB.fromPool(1.0F - f, bottom, 0.0F, 1.0F, top, 1.0F);
             case 2:
-                return AABB.getTemporaryBB(0.0F, bottom, 1.0F - f, 1.0F, top, 1.0F);
+                return AABB.fromPool(0.0F, bottom, 1.0F - f, 1.0F, top, 1.0F);
             case 3:
-                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, f, top, 1.0F);
+                return AABB.fromPool(0.0F, bottom, 0.0F, f, top, 1.0F);
             default:
-                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, 1.0F, top, 1.0F);
+                return AABB.fromPool(0.0F, bottom, 0.0F, 1.0F, top, 1.0F);
         }
     }
     
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index ea9cf35b6..da3ebee64 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -64,7 +64,7 @@ public class BlockLogicFarmland extends BlockLogic implements IBonemealable
 	@Override
 	public AABB getCollisionBoundingBoxFromPool(final WorldSource world, final int x, final int y, final int z)
 	{
-		return AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1);
+		return AABB.fromPool(x, y, z, x + 1, y + 1, z + 1);
 	}
 
 	@Override
@@ -72,9 +72,9 @@ public class BlockLogicFarmland extends BlockLogic implements IBonemealable
 		final Material material = world.getBlockMaterial(x, y + 1, z);
 		if (material == Material.vegetable)
 		{
-			return AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
+			return AABB.fromPool(0, 0, 0, 1, 1, 1);
 		} else {
-			return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
+			return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
 		}
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
index 0f000cc75..356cffe02 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
@@ -80,19 +80,19 @@ public class BlockLogicFence extends BlockLogic implements IPaintable
         boolean connectZNeg = canConnectTo(world, x, y, z - 1);
         final double thickness = 0.5 - 0.375;
         if (connectXPos) {
-            addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - thickness, 0, 0.5 - thickness, 1, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 1, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
         }
         if (connectXNeg) {
-            addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
         }
         if (connectZPos) {
-            addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 1).move(x, y, z), aabbList);
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 1).move(x, y, z), aabbList);
         }
         if (connectZNeg) {
-            addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - thickness, 0, 0, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
         }
         if (!connectXPos && !connectXNeg && !connectZPos && !connectZNeg) {
-            addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
+            addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
         }
     }
 
@@ -121,7 +121,7 @@ public class BlockLogicFence extends BlockLogic implements IPaintable
         boolean connectXNeg = canConnectTo(world, x - 1, y, z);
         boolean connectZPos = canConnectTo(world, x, y, z + 1);
         boolean connectZNeg = canConnectTo(world, x, y, z - 1);
-        return AABB.getTemporaryBB((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
+        return AABB.fromPool((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
index a35edb2b4..4159c16f1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
@@ -45,11 +45,11 @@ public class BlockLogicFenceGate extends BlockLogic implements IPaintable
     {
     	if (getDirection(meta) == 3 || getDirection(meta) == 1)
     	{
-    		return AABB.getTemporaryBB(0.375f, 0, 0, 1 - 0.375f, 1.0F, 1f);
+    		return AABB.fromPool(0.375f, 0, 0, 1 - 0.375f, 1.0F, 1f);
     	}
     	else
     	{
-    		return AABB.getTemporaryBB(0, 0, 0.375f, 1, 1.0f, 1 - 0.375f);
+    		return AABB.fromPool(0, 0, 0.375f, 1, 1.0f, 1 - 0.375f);
     	}
 
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
index 7306274d1..1240372f5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
@@ -25,7 +25,7 @@ public abstract class BlockLogicFenceThin extends BlockLogic
         boolean connectXNeg = canConnectTo(world, x - 1, y, z);
         boolean connectZPos = canConnectTo(world, x, y, z + 1);
         boolean connectZNeg = canConnectTo(world, x, y, z - 1);
-        return AABB.getTemporaryBB((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
+        return AABB.fromPool((connectXNeg ? 0.0f : 0.375f), 0, (connectZNeg ? 0.0f : 0.375f), 1 - (connectXPos ? 0.0f : 0.375f), 1, 1 - (connectZPos ? 0.0f : 0.375f));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 085493472..6467a8ab8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -109,7 +109,7 @@ public abstract class BlockLogicFluid extends BlockLogic
 
     private Vec3 getFlow(WorldSource world, int x, int y, int z)
     {
-        Vec3 result = Vec3.getTempVec3(0.0D, 0.0D, 0.0D);
+        Vec3 result = Vec3.fromPool(0.0D, 0.0D, 0.0D);
         int depthLocal = getRenderedDepth(world, x, y, z);
         for(int i = 0; i < 4; i++)
         {
@@ -325,7 +325,7 @@ public abstract class BlockLogicFluid extends BlockLogic
         float f8 = BlockLogicFluid.getFluidHeight(world, x, y, z + 1, material);
         float f9 = BlockLogicFluid.getFluidHeight(world, x + 1, y, z + 1, material);
         float f10 = BlockLogicFluid.getFluidHeight(world, x + 1, y, z, material);
-        return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, Math.max((f7 + f8 + f9 + f10)/4f, 0.2), 1.0F);
+        return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, Math.max((f7 + f8 + f9 + f10)/4f, 0.2), 1.0F);
     }
 
     public static float getFluidHeight(WorldSource worldSource, int x, int y, int z, Material material)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
index 3d55beaf9..a0393aad8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
@@ -43,7 +43,7 @@ public class BlockLogicJar extends BlockLogic {
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        return AABB.getTemporaryBB(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.375f, 1 - 0.3125f);
+        return AABB.fromPool(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.375f, 1 - 0.3125f);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
index bde6e498a..eba3aa260 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
@@ -38,7 +38,7 @@ public class BlockLogicJarButterfly extends BlockLogic {
         float offset = 0.0F;
         if ((metadata & MASK_HANGING) != 0)
             offset = 0.3875F;
-        return AABB.getTemporaryBB(0.3125f, offset,  0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
+        return AABB.fromPool(0.3125f, offset,  0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
index e6849807b..067eccb4c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
@@ -35,13 +35,13 @@ public class BlockLogicLadder extends BlockLogic {
 		float width = 3.0f / 16.0f;
 
 		if(side == Side.SOUTH) {
-			return AABB.getTemporaryBB(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, width);
+			return AABB.fromPool(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, width);
 		}else if(side == Side.WEST) {
-			return AABB.getTemporaryBB(1.0f - width, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
+			return AABB.fromPool(1.0f - width, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
 		}else if(side == Side.EAST) {
-			return AABB.getTemporaryBB(0.0f, 0.0f, 0.0f, width, 1.0f, 1.0f);
+			return AABB.fromPool(0.0f, 0.0f, 0.0f, width, 1.0f, 1.0f);
 		}else {
-			return AABB.getTemporaryBB(0.0f, 0.0f, 1.0f - width, 1.0f, 1.0f, 1.0f);
+			return AABB.fromPool(0.0f, 0.0f, 1.0f - width, 1.0f, 1.0f, 1.0f);
 		}
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
index 2ca562e4b..e85ac1ade 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
@@ -37,7 +37,7 @@ public class BlockLogicLanternFirefly extends BlockLogic {
         float offset = 0.0F;
         if ((metadata & MASK_HANGING) != 0)
             offset = 0.3875F;
-        return AABB.getTemporaryBB(0.3125f, offset,  0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
+        return AABB.fromPool(0.3125f, offset,  0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
index 15424f0a8..b50b13458 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
@@ -34,6 +34,6 @@ public abstract class BlockLogicLayerBase extends BlockLogic
     {
         int l = world.getBlockMetadata(x, y, z) & 7;
         float f = (float)(2 * (1 + l)) / 16F;
-        return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
+        return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
index f621491c2..349b7a37f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
@@ -223,19 +223,19 @@ public class BlockLogicLever extends BlockLogic
         int rotation = getRotation(world.getBlockMetadata(x, y, z));
         float f = 0.1875F;
         if(rotation == ROTATION_EAST) {
-            return AABB.getTemporaryBB(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
+            return AABB.fromPool(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
         } else if(rotation == ROTATION_WEST) {
-            return AABB.getTemporaryBB(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
+            return AABB.fromPool(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
         } else if(rotation == ROTATION_SOUTH) {
-            return AABB.getTemporaryBB(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
+            return AABB.fromPool(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
         } else if(rotation == ROTATION_NORTH) {
-            return AABB.getTemporaryBB(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
+            return AABB.fromPool(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
         } else if (rotation == ROTATION_TOP_NS || rotation == ROTATION_TOP_WE) {
             float f1 = 0.25F;
-            return AABB.getTemporaryBB(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+            return AABB.fromPool(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
         } else {
             float f1 = 0.25F;
-            return AABB.getTemporaryBB(0.5F - f1, 0.4, 0.5F - f1, 0.5F + f1, 1F, 0.5F + f1);
+            return AABB.fromPool(0.5F - f1, 0.4, 0.5F - f1, 0.5F + f1, 1F, 0.5F + f1);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
index 27e3a4e03..1ab71f573 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
@@ -20,7 +20,7 @@ public class BlockLogicNetherrackIgneous extends BlockLogic {
     public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         float f = 0.125F;
-        return AABB.getTemporaryBB(x, y, z, x + 1, (float)(y + 1) - f, z + 1);
+        return AABB.fromPool(x, y, z, x + 1, (float)(y + 1) - f, z + 1);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
index 2b9271246..baf29ee2c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
@@ -21,7 +21,7 @@ public class BlockLogicPathDirt extends BlockLogic
     @Override
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        return AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1);
+        return AABB.fromPool(x, y, z, x + 1, y + 1, z + 1);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java
index 23709a9e8..370c75b1a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java
@@ -27,6 +27,6 @@ public class BlockLogicPiePumpkin extends BlockLogicEdible
         float xMin = l >= 2 ? 0.5f : f;
         float zMin = l >= 3 ? 0.5f : f;
         float f2 = 0.375F;
-        return AABB.getTemporaryBB(xMin, 0.0F, zMin, 1.0F - f, f2, 1.0F - f);
+        return AABB.fromPool(xMin, 0.0F, zMin, 1.0F - f, f2, 1.0F - f);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
index 85d7ac890..6de96e93e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
@@ -53,12 +53,12 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         {
             float f1 = 0.125F;
             float f3 = 0.5F;
-            return AABB.getTemporaryBB(0.5F - f1, 0.0F, 0.5F - f3, 0.5F + f1, 1.0F, 0.5F + f3);
+            return AABB.fromPool(0.5F - f1, 0.0F, 0.5F - f3, 0.5F + f1, 1.0F, 0.5F + f3);
         } else
         {
             float f = 0.5F;
             float f2 = 0.125F;
-            return AABB.getTemporaryBB(0.5F - f, 0.0F, 0.5F - f2, 0.5F + f, 1.0F, 0.5F + f2);
+            return AABB.fromPool(0.5F - f, 0.0F, 0.5F - f2, 0.5F + f, 1.0F, 0.5F + f2);
         }
     }
 
